/*
 * lxdash-f.n.c
 * Copyright (C) 2008-2011, 2013-2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <e4.h>
#include <lxcall.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))

#define l_LINE(e, output) \
    {									      \
	X1f4_E4_C_USER *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxdash_n_forward(void *context, void *output, void **input)
{
    int status;
    struct dxdash_type *dxdash_data;
    struct lxdash_type *lxdash_data;

    dxdash_data = I_LINE(input[0]);

    lxdash_data = context;

    if (lock_exline(dxdash_data)->call == 1) {
	if (dxdash_data->size) {
	    status = _libx1f4i0_lxdash_null_line(context, NULL, dxdash_data);
	} else {
	    status = 0;
	}
    } else {
	status = _libx1f4i0_lxdash_line_line(lxdash_data, input[0]);
	if (status) {
	} else {
	    status = _libx1f4i0_lxcall_near_node
		(&lxdash_data->link_v, &lxdash_data->link_e,
		 lxdash_data->link_t.datatype, dxdash_data);
	}
    }

    return status;
}
