/*
 * lxdash-n.c.c
 * Copyright (C) 2008-2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <d_fset.h>
#include <e4.h>
#include <lxcall.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))

#define dxdash(dxdash) \
    ((struct dxdash_type *) (dxdash))

int
_libx1f4i0_lxdash_c_nearest(void *context, void *output, void **input)
{
    int status;
    struct dxdash_type *dxdash_data, *dxdash_text;
    void *subtext;

    dxdash_data = I_LINE(input[0]);
    dxdash_text = I_LINE(input[1]);

    subtext = context;

    if (dxdash_data == dxdash_text) {
	status = 0;
    } else {
	void *dxtext;

	status = _libx1f4i0_lxdash_line_line(subtext, &dxtext);
	if (status) {
	} else {
	    void *becca[3];

	    becca[0] = context;
	    becca[2] = dxdash_data;

	    status = _libx1f4i0_line_lxfset
		(dxdash(dxtext)->dash, dxdash_text->dash,
		 _libx1f4i0_lxdash_link_link, _libx1f4i0_lxdash_free_link,
		 becca);
	    if (status) {
		status = _libx1f4i0_lxdash_stat_line(context, 0, status);
	    } else {
		dxdash(dxtext)->size = dxdash_text->size;

		status = _libx1f4i0_lxdash_null_line
		    (context, NULL, dxdash_data);
		if (status) {
		} else {
		    status = _libx1f4i0_lxdash_swap_line(dxtext, dxdash_data);
		}
	    }

	    if (1) {
		int excess;

		excess = _libx1f4i0_lxdash_flat_line(subtext, &dxtext);
		if (excess) {
		    status = _libx1f4i0_lxcall_land_slip(excess, status);
		}
	    }
	}
    }

    return status;
}
