/*
 * lxline-e.k.c
 * Copyright (C) 2010-2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxline-defs.h>
#include <lxline-inter.h>
#include <lxline-types.h>
#include <lxwide.h>

int
x1f4_tile_lxline(void **lxline, unsigned bits,
		 struct x1f4_lxwide_type *lxwide_data, unsigned tile,
		 const void *data)
{
    int status, type;
    struct screen_type screen;
    unsigned flags;

    if (data) {
	screen = *(const struct screen_type *) data;
    }

    flags = tile;

    if (1) {
	screen.lock_t.data = lxwide_data->datatype_set.nodetype_data;
	screen.lock_t.miss = lxwide_data->datatype_set.miss;
    }

    if (1) {
	lxwide_data->widetype_set.type++;
	screen.link_l.type = lxwide_data->widetype_set.type;
    }

    if (1) {
	screen.link_o.fine = lxwide_data->transfer_set.fine;
    }

    if (x1f4_mind_lxwide(&type, lxwide_data, "data", 4)) {
	flags |= DATALINK_LINK;
	screen.lock_f.type = type;
    }

    if (1) {
	if (flags & TRANSFER_LINK) {
	} else {
	    flags |= TRANSFER_LINK;
	    screen.link_o.fine = lxwide_data->transfer_set.fine;
	}
    }

    if (bits & X1f4_LXWIDE_CODELINK) {
	if (flags & CODELINK_LINK) {
	} else {
	    flags |= CODELINK_LINK;
	    screen.lock_w.data = lxwide_data->codelink_set.data;
	    screen.lock_w.free = lxwide_data->codelink_set.free;
	    screen.lock_w.link = lxwide_data->codelink_set.link;
	    screen.lock_w.mode = lxwide_data->codelink_set.mode;
	}
    }

    if (1) {
	if (flags & AUTOLINK_LINK) {
	} else {
	    flags |= AUTOLINK_LINK;
	    screen.lock_v.data = lxwide_data->autolink_set.data;
	    screen.lock_v.free = lxwide_data->autolink_set.free;
	    screen.lock_v.link = lxwide_data->autolink_set.link;
	    screen.lock_v.mode = lxwide_data->autolink_set.mode;
	    screen.lock_v.pick = lxwide_data->autolink_set.pick;
	    screen.lock_v.slip = lxwide_data->autolink_set.slip;
	}
    }

    if (bits & X1f4_LXWIDE_MISSBAIL) {
	if (flags & MISSBAIL_LINK) {
	} else {
	    flags |= MISSBAIL_LINK;
	    screen.lock_r.call = lxwide_data->missbail_set.call;
	    screen.lock_r.fine = lxwide_data->missbail_set.fine;
	    screen.lock_r.miss = lxwide_data->missbail_set.miss;
	    screen.lock_r.text = lxwide_data->missbail_set.text;
	}
    }

    if (bits & X1f4_LXWIDE_RELATION) {
	if (flags & RELATION_LINK) {
	} else {
	    flags |= RELATION_LINK;
	    screen.link_y.linetrap_data =
		lxwide_data->relation_set.linetrap_data;
	}
    }

    if (bits & X1f4_LXWIDE_RESOURCE) {
	if (flags & RESOURCE_LINK) {
	} else {
	    flags |= RESOURCE_LINK;
	    screen.lock_m.data = lxwide_data->resource_set.data;
	    screen.lock_m.free = lxwide_data->resource_set.free;
	    screen.lock_m.link = lxwide_data->resource_set.link;
	    screen.lock_m.mode = lxwide_data->resource_set.mode;
	}
    }

    if (1) {
	if (flags & EELOOKUP_LINK) {
	} else {
	    flags |= EELOOKUP_LINK;
	    screen.lock_g.eelookup_data =
		lxwide_data->eelookup_set.eelookup_data;
	}
    }

    if (bits & X1f4_LXWIDE_TEXTFLAT) {
	if (flags & TEXTFLAT_LINK) {
	} else {
	    flags |= TEXTFLAT_LINK;
	    screen.lock_e.data = lxwide_data->textflat_set.data;
	    screen.lock_e.line = lxwide_data->textflat_set.line;
	    screen.lock_e.post = lxwide_data->textflat_set.post;
	    screen.lock_e.push = lxwide_data->textflat_set.push;
	}
    }

    status = _libx1f4i0_lxline_init_line(lxline, flags, &screen);
    if (status) {
    } else {
    }

    return status;
}
