/*
 * lxline-p.w.c
 * Copyright (C) 2011-2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lxcast.h>
#include <lxline-inter.h>
#include <lxline-types.h>

#define I_LIST(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_MODE(t)			(*((X1f4_E4_C_MODE *) (t)))
#define I_USER(t)			(*((X1f4_E4_C_USER *) (t)))

extern const void *const x1f4_a1_walk_link;

int
_libx1f4i0_lxline_w_pending(void *context, void *output, void **input)
{
    int status;

    do {
	X1f4_E4_C_MODE jack, lock;
	struct dxline_type *dxline_data;
	struct x1f4_dxcast_type *dxcast_data;
	const struct x1f4_function_type *function_text;
	struct x1f4_linetext_type *linetext_data;
	unsigned class, count, grade;
	void **track, **used;

	if (output == x1f4_a1_walk_link) {
	    track = input[1];
	} else {
	    track = input;
	}

	used = track[-1];

	dxcast_data = I_USER(track[1]);

	if (X1f4_E4_CALL < dxcast_data->type) {
	} else {
	    status = _libx1f4i0_lxline_stat_roll(context, "r_wcall", 7);
	    break;
	}

	linetext_data = I_USER(&dxcast_data->data);

	if (linetext_data->function.function) {
	} else {
	    status = _libx1f4i0_lxline_stat_zero(context, "r_wcall", 7);
	    break;
	}

	dxline_data = I_LIST(track[0]);

	function_text = used[X1f4_E4_RENDITION];

	class = function_text->count - 4;

	grade = class + 1;

	jack = I_MODE(track[2]);

	if (jack < -(int) grade || !(jack < (int) grade)) {
	    status = _libx1f4i0_lxline_stat_land(context, grade, jack);

	    break;
	}

	if (jack < (X1f4_E4_C_MODE) 0) {
	    jack += grade;
	}

	grade++;

	lock = I_MODE(track[3]);

	if (lock < -(int) grade || !(lock < (int) grade)) {
	    status = _libx1f4i0_lxline_stat_land(context, grade, lock);

	    break;
	}

	if (lock < (X1f4_E4_C_MODE) 0) {
	    lock += grade;
	}

	count = dxline_data->size;
	if (count) {
	    status = _libx1f4i0_lxline_will_list
		(context, output, input, track, linetext_data, count,
		 function_text, 4, jack, lock, dxline_data);
	} else {
	    status = 0;

	    if (output == x1f4_a1_walk_link) {
		input[2] = NULL;
	    }
	}
    } while (0);

    return status;
}

