/*
 * lxlist-l.n.c
 * Copyright (C) 2008-2011, 2013-2015, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <l_list.h>
#include <lxcall.h>
#include <lxlist-drive.h>
#include <lxlist-inter.h>
#include <lxlist-types.h>

#define I_LIST(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_MODE(t)			(*((X1f4_E4_C_MODE *) (t)))

#define l_USER(e, output) \
    {									      \
	X1f4_E4_C_USER *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxlist_n_logique(void *context, void *output, void **input)
{
    int status;

    do {
	X1f4_E4_C_MODE mode;
	struct dxlist_type *dxlist_data;
	struct lxtext_type *lxtext_data;
	unsigned type;
	void *data;

	lxtext_data = context;

	mode = I_MODE(input[1]);

	dxlist_data = I_LIST(input[0]);
	if (0) {
	} else {
	    unsigned size;

	    size = dxlist_data->size + 1;
	    if (mode < -(X1f4_E4_C_MODE) (int) size
		|| !(mode < (X1f4_E4_C_MODE) (int) size)) {
		status = _libx1f4i0_lxlist_stat_deck
		    (lxtext_data->text, size, mode);

		break;
	    } else {
		if (mode < 0) {
		    mode += size;
		}
	    }
	}

	type = lxtext_data->lxtype.code;

	status = _libx1f4i0_push_l4list(dxlist_data->list, mode, &data);
	if (status) {
	    status = _libx1f4i0_lxlist_stat_list(lxtext_data->text, 0, status);
	} else {
	    unsigned link;
	    void *post;

	    type_effect(data, type);

	    status = lxtext_data->lxtype.post
		(lxtext_data->lxtype.context, &post, lock_excase(dxlist_data));
	    if (status) {
		link_effect(data, ~0);

		_libx1f4i0_miss_l4list(dxlist_data->list, mode);

		break;
	    } else {
		struct lxlist_type *lxlist_data;

		lxlist_data = lxtext_data->text;

		l_USER(post, byte(data) + 8);

		dxlist_data->size++;

		link = lxtext_data
		    - ((struct lxtext_type *) lxlist_data->link_f.text);

		if (lxtext_data->lxtype.lead) {
		    status = x1f4_auto_node
			(&lxlist_data->link_v, &lxlist_data->link_e,
			 &lxtext_data->lxtype, &post, output);
		} else {
		    l_USER(post, output);
		}
	    }

	    link_effect(data, link);
	}
    } while (0);

    return status;
}
