/*
 * lxmath-o.x.c
 * Copyright (C) 2011-2013, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lxmath-inter.h>

#define I_BILL(t)			(*((X1f4_E4_C_BILL *) (t)))
#define I_MODE(t)			(*((X1f4_E4_C_MODE *) (t)))

#define l_BILL(e, output) \
    {									      \
	X1f4_E4_C_BILL *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxmath_j120812_1(void *context, void *output, void **input)
{
    X1f4_E4_C_MODE rate;
    int status = 0;

    rate = I_MODE(input[1]);
    if (rate) {
	X1f4_E4_C_BILL call;

	call = I_BILL(input[0]) % rate;

	l_BILL(call, output);
	l_BILL(call, input[0]);
    } else {
	status = _libx1f4i0_lxmath_stat_zero(context);
    }

    return status;
}
