/*
 * lxrail-types.h
 * Copyright (C) 2016, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxrail_types_H__
#define __LIBx1f4_lxrail_types_H__

#include <ct.h>
#include <e4.h>
#include <fd.h>
#include <it.h>
#include <e4.h>
#include <lxplus.h>
#include <nt.h>

#define lxtype_type                     x1f4_nodetype_type

typedef struct affect_type {
    int link, type;
    struct fxdata_type fxdata, fxtext;
} affect_type;

typedef struct depart_type {
    struct x1f4_fpdetail_type *fpdetail_qlaw, *fpdetail_xlaw;
    struct x1f4_ftaa_type *ftaa_qlaw, *ftaa_xlaw;
    struct x1f4_ftca_type *ftca_qlaw, *ftca_xlaw;
    const void *screen_data;
} depart_type;

typedef struct lxtext_type {
    struct lxtype_type lxtype;
    void *text;
} lxtext_type;

typedef struct lxrail_type {
    struct lxplus_type ever_p;
    struct {
	void *data, *side, *text;
    } link_f;
    struct x1f4_iturn_type link_p;
    struct x1f4_cturn_type link_q;
} lxrail_type;

#endif				/* __LIBx1f4_lxrail_types_H__ */
