/*
 * qscb.i.c
 * Copyright (C) 2010-2012, 2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <qscc-defs.h>
#include <qscc-inter.h>
#include <qscc-names.h>
#include <qscc-types.h>

#define qsrate(qsrate)			((struct qsrate_type *) (qsrate))

int
_libx1f4l2_mall_qsrate(void *qsrate, unsigned rate)
{
    int status;

    rate--;
    if (rate) {
	int (*link) (void *, void **, unsigned);
	unsigned size;
	void *data, *node;

	size =
	    sizeof(struct fpnode_type) << qsrate(qsrate)->link_a.fplist.lock;

	data = qsrate(qsrate)->link_m.data;
	link = qsrate(qsrate)->link_m.link;

	do {
	    status = link(data, &node, size);
	    if (status) {
		break;
	    } else {
		struct fplink_type *fplink_data;

		fplink_data = node;
		fplink_data->fplink_data = qsrate(qsrate)->link_e.fplink_data;
		qsrate(qsrate)->link_e.fplink_data = node;
	    }

	    rate--;
	} while (rate);

	if (rate) {
	    status = LINK_ERROR;
	    if (1) {
		_libx1f4l2_fade_qsrate(qsrate);
	    }
	}
    } else {
	status = 0;
    }

    return status;
}
