/*
 * qscb.w.c
 * Copyright (C) 2013, 2014, 2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <qscc-defs.h>
#include <qscc-names.h>
#include <qscc-types.h>

#define qsrate(qsrate)			((struct qsrate_type *) (qsrate))

int
_libx1f4l2_wrap_qsrate(void *qsrate, unsigned lock, unsigned rate)
{
    int status;
    struct fpnode_type *fpnode_data;
    unsigned node;
    void *star;

    fpnode_data = qsrate(qsrate)->link_a.fplist.fpnode;

    for (;;) {
	node = fpnode_data->node;
	if (node) {
	    break;
	}

	fpnode_data++;
    }

    star = fpnode_data->star;

    status = qsrate(qsrate)->link_m.free
	(qsrate(qsrate)->link_m.data, qsrate(qsrate)->link_a.fplist.fpnode);
    if (status) {
	status = FREE_ERROR;
    } else {
	if (rate) {
	    qsrate(qsrate)->link_a.fplist.node = node;

	    qsrate(qsrate)->link_a.fplist.rate = rate;

	    qsrate(qsrate)->link_a.fplist.fpnode = star;

	    if (node == 1) {
		status = _libx1f4l2_wrap_qsrate(qsrate, lock, rate - 1);
	    }
	} else {
	    status = qsrate(qsrate)->link_m.mode
		(qsrate(qsrate)->link_m.data, &star,
		 qsrate(qsrate)->link_a.fplist.line * 3
		 * qsrate(qsrate)->link_a.fplist.mall >> 1);
	    if (status) {
		status = MODE_ERROR;
	    }

	    qsrate(qsrate)->link_a.fplist.rate = 0;

	    qsrate(qsrate)->link_a.fplist.fpnode = star;

	    star = qsrate(qsrate)->link_e.fplink_text;
	    if (star) {
		int excess;

		excess = qsrate(qsrate)->link_m.free
		    (qsrate(qsrate)->link_m.data, star);
		if (excess) {
		    if (status) {
		    } else {
			status = FREE_ERROR;
		    }
		} else {
		    qsrate(qsrate)->link_e.fplink_text = NULL;
		}
	    }
	}

	if (1) {
	    struct fplink_type *fplink_data;

	    fplink_data = (void *) qsrate(qsrate)->link_e.fplink_data;
	    if (fplink_data) {
		int excess;

		qsrate(qsrate)->link_e.fplink_data = fplink_data->fplink_data;

		excess = qsrate(qsrate)->link_m.free
		    (qsrate(qsrate)->link_m.data, fplink_data);
		if (excess) {
		    qsrate(qsrate)->link_e.fplink_data = fplink_data;
		    if (status) {
		    } else {
			status = FREE_ERROR;
		    }
		}
	    }
	}
    }

    return status;
}
